$execute store result score @s bungeon.temp run data get storage bungeon:data player.$(name).playtime
$execute store result storage bungeon:data player.$(name).playtime int 1 run scoreboard players add @s bungeon.temp 1

attribute @s minecraft:attack_damage base set 0
attribute @s minecraft:attack_speed base set 4
attribute @s minecraft:fall_damage_multiplier base set 0

# Remove Vanilla Systems
effect give @s minecraft:resistance infinite 255 true
effect give @s minecraft:saturation infinite 255 true

# Give coins
execute if items entity @s container.* gold_nugget run function bungeon:player/run/stats/coins

# Drop Items
execute unless data entity @s SelectedItem at @n[type=item, distance=..2, nbt={Age:0s}] run function bungeon:player/run/item/drop/init with storage bungeon:data
execute if entity @n[type=item, distance=..2, nbt={Age:0s}, nbt=!{Item:{id:"minecraft:gold_nugget"}}] run function bungeon:hub/gui/reorder
kill @n[type=item, distance=..2, nbt={Age:0s}, nbt=!{Item:{id:"minecraft:gold_nugget"}}]

# Held Item
scoreboard players set @s[scores={bungeon.detect_left_click=-1}] bungeon.detect_left_click 1
scoreboard players remove @s[scores={bungeon.detect_left_click=2..}] bungeon.detect_left_click 1
execute unless score @s bungeon.transfer matches -2147483648..2147483647 run function bungeon:player/run/item/held/redirect
$execute if score @s bungeon.transfer matches 0.. run function bungeon:player/run/item/held/transfer/upgrade/tick with storage bungeon:data player.$(name).run.gui.transfer
execute if score @s bungeon.transfer matches ..-1 run function bungeon:player/run/item/held/transfer/coins/tick
execute anchored eyes run function bungeon:player/run/item/use/left_click/detection/init with storage bungeon:data

# Teleport other players inside room
function bungeon:dungeon/room/activate/check_lock with storage bungeon:data run.room_lock

# Predicting enemies
execute if data storage bungeon:data {option:{difficulty:0}} run function bungeon:player/prediction/off with storage bungeon:data
execute if data storage bungeon:data {option:{difficulty:1}} run function bungeon:player/prediction/on with storage bungeon:data

# Statistics
execute store result storage bungeon:data temp float 0.001 run function bungeon:player/run/stats/fetch/speed with storage bungeon:data
function bungeon:player/run/stats/update_speed with storage bungeon:data

function bungeon:player/run/health/update with storage bungeon:data
execute unless score @s bungeon.poison matches 10.. run scoreboard players add @s bungeon.poison 1
scoreboard players remove @s[scores={bungeon.cooldown=1..}] bungeon.cooldown 100
scoreboard players remove @s bungeon.iframe 1

item replace entity @s player.cursor with air

execute if entity @n[type=item_display, tag=exit, distance=..4] positioned ~ -4 ~ as @s[dy=2] at @s run return run function bungeon:dungeon/shop/teleport/init
execute positioned ~ -6 ~ as @s[dy=2] run function bungeon:player/run/health/pitfall with storage bungeon:data